#include <cstdlib>
#include <ctime>
#include <iostream>
#include <string>
#include <cstdio>
#include <sstream>

using namespace std;

const int MAXC = 99, MAXV = 999999, MAXS = 999, OFFSET = 1000;

void gen_rand_test(const char *fname, int n, int m) {
	freopen(fname, "w", stdout);

	cout << n << " " << m << endl;
	int pos = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			int c = rand() % MAXC + 1;
			cout << c << " ";

			for (int k = 0; k < c; k++) {
				int maxv = MAXV - OFFSET * pos;
				int a = rand() % (maxv / c) + (maxv / c) * k, b = rand() % ((maxv / c)*(k + 1) - a) + a + 1;
				a += OFFSET * pos; b += OFFSET * pos;

				cout << a << " " << b << " ";
			}
			pos++;
			cout << endl;
		}
}
                                               
int main(int argc, char *argv[]) {	
	stringstream is(""); is << argv[1] << " " << argv[2] << " " << argv[3];
	int seed, n, m; is >> seed >> n >> m;
	srand(seed);               
                                       
	gen_rand_test("gen.out", n, m);

}